/*
 * J5-0_USART3.c
 *
 *  Created on: 2024518
 *      Author: 34509
 */
#include "J5-0_USART3.h"
#include "uart_dev.h"


void USART3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));



/* ջ */
uint8_t USART3_Rbuffer[1] = {0x00};

/*
 * Function Name  : J5_0_485_Init
 * Description    : ʼ3ڿJ5-06485ӿ,ÿƵ485ΪJ0.
 * Input          : None
 * Return         : None
 **/
void J5_0_485_Init(uint32_t baud)
{
    rt_pin_mode(J5_PWR_Ctrl, PIN_MODE_OUTPUT);
    rt_pin_mode(J6_PWR_Ctrl, PIN_MODE_OUTPUT);
    rt_pin_mode(J7_PWR_Ctrl, PIN_MODE_OUTPUT);
    rt_pin_mode(J8_PWR_Ctrl, PIN_MODE_OUTPUT);
    rt_pin_mode(J9_PWR_Ctrl, PIN_MODE_OUTPUT);

    rt_pin_mode(USART3_DE, PIN_MODE_OUTPUT);
    /* 485״̬Ϊ */
    rt_pin_write(USART3_DE, read);

    rt_pin_mode(TD_USART_A, PIN_MODE_OUTPUT);
    rt_pin_mode(TD_USART_B, PIN_MODE_OUTPUT);
    rt_pin_mode(TD_USART_C, PIN_MODE_OUTPUT);
    /* USART3J0 485 */
    USART_CONNET_J0();


    GPIO_InitTypeDef   GPIO_InitStructure;
    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* USART3  TX --> PB10   RX --> PB11  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PB10Ϊ
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PB11Ϊ
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(USART3, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;      //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;           //ȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);
//    USART_ITConfig(USART3, USART_IT_IDLE, ENABLE);

    USART_Cmd(USART3,ENABLE);
}



void USART3_IRQHandler(void)
{
    if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET) //жϲ
    {
//        USART_ClearITPendingBit(USART3,USART_IT_RXNE);                //жϱ־
//        USART_Rbuffer[USART_Rbuffer_Num] = USART_ReceiveData(USART3); //
//        USART_Rbuffer_Num++;
        USART3_Rbuffer[0] = USART_ReceiveData(USART3); //
        uint8_t c = 0;
        uart_device_info *dev = (uart_device_info *)g_J50RS485_USART3_handle;
        c = USART3_Rbuffer[0];
        if(!RingQueueFull(&dev->uart_ring_queue))
           InRingQueue(&dev->uart_ring_queue, c);
    }

//    if(USART_GetITStatus(USART3, USART_IT_IDLE) != RESET) //жϲ
//    {
////        for(USART_Tbuffer_Num=0;USART_Tbuffer_Num < USART_Rbuffer_Num;USART_Tbuffer_Num++)
////        {
////            USARTx_SendByte(USART3, USART_Rbuffer[USART_Tbuffer_Num]); //
////        }
//        USARTx_SendStr_Len(USART3, USART_Rbuffer, USART_Rbuffer_Num);
//        rt_kprintf("USART_Rbuffer_Num = %d \n", USART_Rbuffer_Num);
////        USART3->STATR;
////        USART3->DATAR;
//        USART_Rbuffer_Num = 0; //ʼ
//        USART_ReceiveData(USART3);               //DR
//    }
//
//    if(USART_GetFlagStatus(USART3,USART_FLAG_ORE) == SET) //
//    {
//        USART_ClearFlag(USART3,USART_FLAG_ORE);  //־
//        USART_ReceiveData(USART3);               //DR
//    }
}

/*
 * Function Name  : USART_CONNET_J0
 * Description    : ƴ3J0Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J0(void)
{
    J5_PWR_Close();
    J6_PWR_Close();
    J7_PWR_Close();
    J8_PWR_Close();
    J9_PWR_Close();
    rt_pin_write(TD_USART_A, PIN_LOW);
    rt_pin_write(TD_USART_B, PIN_LOW);
    rt_pin_write(TD_USART_C, PIN_LOW);
}

/*
 * Function Name  : USART_CONNET_J5
 * Description    : ƴ3J5Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J5(void)
{
    J5_PWR_Open();
    J6_PWR_Close();
    J7_PWR_Close();
    J8_PWR_Close();
    J9_PWR_Close();
    rt_pin_write(TD_USART_A, PIN_LOW);
    rt_pin_write(TD_USART_B, PIN_LOW);
    rt_pin_write(TD_USART_C, PIN_LOW);
}

/*
 * Function Name  : USART_CONNET_J6
 * Description    : ƴ3J6Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J6(void)
{
    J5_PWR_Close();
    J6_PWR_Open();
    J7_PWR_Close();
    J8_PWR_Close();
    J9_PWR_Close();
    rt_pin_write(TD_USART_A, PIN_HIGH);
    rt_pin_write(TD_USART_B, PIN_LOW);
    rt_pin_write(TD_USART_C, PIN_LOW);
}

/*
 * Function Name  : USART_CONNET_J7
 * Description    : ƴ3J7Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J7(void)
{
    J5_PWR_Close();
    J6_PWR_Close();
    J7_PWR_Open();
    J8_PWR_Close();
    J9_PWR_Close();
    rt_pin_write(TD_USART_A, PIN_HIGH);
    rt_pin_write(TD_USART_B, PIN_HIGH);
    rt_pin_write(TD_USART_C, PIN_LOW);
}

/*
 * Function Name  : USART_CONNET_J8
 * Description    : ƴ3J8Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J8(void)
{
    J5_PWR_Close();
    J6_PWR_Close();
    J7_PWR_Close();
    J8_PWR_Open();
    J9_PWR_Close();
    rt_pin_write(TD_USART_A, PIN_LOW);
    rt_pin_write(TD_USART_B, PIN_LOW);
    rt_pin_write(TD_USART_C, PIN_HIGH);
}

/*
 * Function Name  : USART_CONNET_J9
 * Description    : ƴ3J9Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J9(void)
{
    J5_PWR_Close();
    J6_PWR_Close();
    J7_PWR_Close();
    J8_PWR_Close();
    J9_PWR_Open();
    rt_pin_write(TD_USART_A, PIN_HIGH);
    rt_pin_write(TD_USART_B, PIN_LOW);
    rt_pin_write(TD_USART_C, PIN_HIGH);
}



void J5_PWR_Open(void)
{
    rt_pin_write(J5_PWR_Ctrl, open);
}


void J5_PWR_Close(void)
{
    rt_pin_write(J5_PWR_Ctrl, close);
}


void J6_PWR_Open(void)
{
    rt_pin_write(J6_PWR_Ctrl, open);
}


void J6_PWR_Close(void)
{
    rt_pin_write(J6_PWR_Ctrl, close);
}


void J7_PWR_Open(void)
{
    rt_pin_write(J7_PWR_Ctrl, open);
}


void J7_PWR_Close(void)
{
    rt_pin_write(J7_PWR_Ctrl, close);
}


void J8_PWR_Open(void)
{
    rt_pin_write(J8_PWR_Ctrl, open);
}


void J8_PWR_Close(void)
{
    rt_pin_write(J8_PWR_Ctrl, close);
}


void J9_PWR_Open(void)
{
    rt_pin_write(J9_PWR_Ctrl, open);
}


void J9_PWR_Close(void)
{
    rt_pin_write(J9_PWR_Ctrl, close);
}
